# Allow incoming connections to ipv4 port {{ ports.openvpn[0]  | default(80) }} for both udp and tcp
add_rule4 -A user-input -p tcp -m tcp -d {{ ips | ansible.utils.ipv4 | first }} --dport {{ ports.openvpn[0]  | default(80) }} -j ACCEPT
add_rule4 -A user-input -p udp -m udp -d {{ ips | ansible.utils.ipv4 | first }} --dport {{ ports.openvpn[0]  | default(80) }} -j ACCEPT
{% if direct_openvpn_access is defined and direct_openvpn_access == false -%}
add_rule4 -I user-input -p udp --dport {{ ports.openvpn[0]  | default(80) }} -j DROP
add_rule4 -I user-input -p tcp --dport {{ ports.openvpn[0]  | default(80) }} -j DROP
{% endif %}


{% if openvpn_tcp_network6 is defined and openvpn_tcp_network6|d('')|length > 0 -%}
# Allow incoming connections to ipv6 port {{ ports.openvpn[0]  | default(80) }} for both udp and tcp
add_rule6 -A user-input -p tcp -m tcp -d {{ ips | ansible.netcommon.ipv6 | first }} --dport {{ ports.openvpn[0]  | default(80) }} -j ACCEPT
add_rule6 -A user-input -p udp -m udp -d {{ ips | ansible.netcommon.ipv6 | first }} --dport {{ ports.openvpn[0]  | default(80) }} -j ACCEPT

{% if direct_openvpn_access is defined and direct_openvpn_access == false -%}
add_rule6 -I user-input -p udp --dport {{ ports.openvpn[0]  | default(80) }} -j DROP
add_rule6 -I user-input -p tcp --dport {{ ports.openvpn[0]  | default(80) }} -j DROP
{% endif %}

{% endif %}


# deny outgoing ports that shouldn't be used
# Strict egress filtering:
# SMTP (TCP 25)
# Trivial File Transfer Protocol - TFTP (UDP 69)
# MS RPC (TCP & UDP 135)
# NetBIOS/IP (TCP/UDP 139 & UDP 137, UDP 138)
# Simple Network Management Protocol – SNMP (UDP/TCP 161-162)
# SMB/IP (TCP/UDP 445)
# Syslog (UDP 514)
# Gamqowi trojan: TCP 4661
# Mneah trojan: TCP 4666
add_rule4 -A FORWARD -i tun0 -p tcp -m multiport --dports 25,135,139,161,162,445,4661,4666 -j DROP
add_rule4 -A FORWARD -i tun1 -p tcp -m multiport --dports 25,135,139,161,162,445,4661,4666 -j DROP
add_rule4 -A FORWARD -i tun0 -p udp -m multiport --dports 69,135,139,137,138,161,162,445,514 -j DROP
add_rule4 -A FORWARD -i tun1 -p udp -m multiport --dports 69,135,139,137,138,161,162,445,514 -j DROP
add_rule6 -A FORWARD -i tun0 -p tcp -m multiport --dports 25,135,139,161,162,445,4661,4666 -j DROP
add_rule6 -A FORWARD -i tun1 -p tcp -m multiport --dports 25,135,139,161,162,445,4661,4666 -j DROP
add_rule6 -A FORWARD -i tun0 -p udp -m multiport --dports 69,135,139,137,138,161,162,445,514 -j DROP
add_rule6 -A FORWARD -i tun1 -p udp -m multiport --dports 69,135,139,137,138,161,162,445,514 -j DROP

# let ipv4 tcp vpn hosts reach the internet
add_rule4 -A FORWARD -s {{ openvpn_tcp_network | ipaddr('network/prefix') }} -o {{ ansible_default_ipv4.interface }} -j ACCEPT
# allow re/established tcp *inbound* to vpn hosts
add_rule4 -A FORWARD -d {{ openvpn_tcp_network | ipaddr('network/prefix') }} -m state --state RELATED,ESTABLISHED -j ACCEPT
# let ipv4 udp vpn hosts reach the internet
add_rule4 -A FORWARD -s {{ openvpn_udp_network | ipaddr('network/prefix') }} -o {{ ansible_default_ipv4.interface }} -j ACCEPT
# allow re/established udp *inbound* to vpn hosts
add_rule4 -A FORWARD -d {{ openvpn_udp_network | ipaddr('network/prefix') }} -m state --state RELATED,ESTABLISHED -j ACCEPT

{% if openvpn_tcp_network6 is defined and openvpn_tcp_network6|d('')|length > 0 -%}
# let ipv6 tcp vpn hosts reach the internet
add_rule6 -A FORWARD -i tun0 -o {{ ansible_default_ipv4.interface }} -s {{ openvpn_tcp_network6 }} -m state --state NEW -j ACCEPT
# let ipv6 udp vpn hosts reach the internet
add_rule6 -A FORWARD -i tun1 -o {{ ansible_default_ipv4.interface }} -s {{ openvpn_udp_network6 }} -m state --state NEW -j ACCEPT
# allow re/established *inbound* to vpn gateways
add_rule6 -A FORWARD -i {{ ansible_default_ipv4.interface }} -m state --state RELATED,ESTABLISHED -j ACCEPT
# deny any unrelated tcp traffic
add_rule6 -A FORWARD -i {{ ansible_default_ipv4.interface }} -o tun0 -d {{ openvpn_tcp_network6 }} -j DROP
# deny any unrelated udp traffic
add_rule6 -A FORWARD -i {{ ansible_default_ipv4.interface }} -o tun1 -d {{ openvpn_udp_network6 }} -j DROP
{% endif %}

# deny v4 tcp client-to-client communication
add_rule4 -A FORWARD -i tun0 -p tcp -o tun0 -j DROP
# deny v4 udp client-to-client communication
add_rule4 -A FORWARD -i tun1 -p udp -o tun0 -j DROP
{% if openvpn_tcp_network6 is defined and openvpn_tcp_network6|d('')|length > 0 -%}
# deny v6 tcp client-to-client communication
add_rule6 -A FORWARD -i tun0 -p tcp -o tun0 -j DROP
# deny v6 udp client-to-client communication
add_rule6 -A FORWARD -i tun1 -p udp -o tun0 -j DROP
{% endif %}

# allow tcp vpn clients to resolve DNS (i.e. query knot-resolver)
add_rule -A user-input -i tun0 -p udp --dport 53 -j ACCEPT
add_rule -A user-input -i tun0 -p tcp --dport 53 -j ACCEPT

# allow udp vpn clients to resolve DNS (i.e. query knot-resolver)
add_rule -A user-input -i tun1 -p udp --dport 53 -j ACCEPT
add_rule -A user-input -i tun1 -p tcp --dport 53 -j ACCEPT

